<?php

namespace Teknisa\PED\Modules\Pedidos\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Error;

class Ped14000ParametrosWebServiceFactory {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }
    

    // BUSCO CLIENTES A INSERIR
    public function getClienteCadAuto($row){
        

        $sql = "SELECT C.CDCLIENTE, C.IDTPIJURCLIE, E.DSEMAILCLIE
                  FROM CLIENTE C, ENDECLIE E
                 WHERE (C.IDCLIEATIV       = 'S'         )
                   AND (E.IDTPENDECLIE (+) = 'P'         )
                   AND (E.CDCLIENTE    (+) = C.CDCLIENTE )
                   AND ((INSTR(:P_CDCLIENTE, C.CDCLIENTE) > 0) OR (:P_CDCLIENTE = 'T'))";
        
        
            $params = array(
                'P_CDCLIENTE'       => $row[0]['CDCLIENTE']
            );
       

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
    // BUSCO CLIENTES QUE JA EXISTEM NA CLIEPEDWEB
    public function getClienteWebClie($cliente, $row){
        
        $sql = "SELECT * FROM CLIEPEDWEB
                WHERE NRSEQWEBSERVICE   = :P_NRSEQWEBSERVICE
                AND CDCLIENTE           = :P_CDCLIENTE";
        
            $params = array(
                'P_NRSEQWEBSERVICE'     => $row[0]['NRSEQWEBSERVICE'],
                'P_CDCLIENTE'           => $cliente['CDCLIENTE']
            );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
    // BUSCO CLIENTES QUE JA EXISTEM NA CLIEWEBSYNC
    public function getClienteWebClieSync($cliente, $row){
        
       $sql = "SELECT * FROM CLIEWEBSYNC
                WHERE NRSEQWEBSERVICE   = :P_NRSEQWEBSERVICE
                AND CDCLIENTE           = :P_CDCLIENTE";
        
            $params = array(
                'P_NRSEQWEBSERVICE'     => $row[0]['NRSEQWEBSERVICE'],
                'P_CDCLIENTE'           => $cliente['CDCLIENTE']
            );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
    public function insertClienteCadAuto($cliente, $row){
        try{
            /* INSERE NA CLIEPEDWEB */
            $sql = "INSERT INTO CLIEPEDWEB
                        (CDCLIENTE, 
                        NRSEQWEBSERVICE,
                        DSEMAILCLIE)
                    VALUES (:P_CDCLIENTE,
                            :P_NRSEQWEBSERVICE,
                            :P_DSEMAILCLIE)";
        
            $params = array(
                'P_CDCLIENTE'       => $cliente['CDCLIENTE'],
                'P_NRSEQWEBSERVICE' => $row[0]['NRSEQWEBSERVICE'],
                ':P_DSEMAILCLIE'     =>$cliente['DSEMAILCLIE']
            );

            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    public function insertClienteSyncCadAuto($cliente, $row){
        try{
            /* INSERE NA CLIEWEBSYNC */
            $sql = "INSERT INTO CLIEWEBSYNC
                        (CDCLIENTE, 
                        NRSEQWEBSERVICE)
                    VALUES (:P_CDCLIENTE,
                            :P_NRSEQWEBSERVICE)";
        
            $params = array(
                'P_CDCLIENTE'       => $cliente['CDCLIENTE'],
                'P_NRSEQWEBSERVICE' => $row[0]['NRSEQWEBSERVICE']
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }

    /*------------------------------------------------------------*/
    
    // BUSCO PRODUTOS A INSERIR
    public function getProduto($row){
        /*BUSCA OS PRODUTOS DE ACORDO COM O INTEVALO SELECIONADO*/
        
        $sql="SELECT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
                   P.SGUNIDADE, I.VRITEPREBASE, I.DTINIVALIPB, I.DTFIMVALIPB,
                   X.VRTOTALPROMO, X.DTINIPROMO, X.DTFINPROMO, P.DSOBSNUTR
              FROM PRODUTO P, ITEMPREBASE I,
                   (
                    SELECT I.CDPRECOBASE, I.CDPRODUTO, B.VRTOTALPROMO,
                           B.DTINIPROMO, B.DTFINPROMO
                      FROM ITEMPREBASE I, PROMOPRBASE B
                     WHERE (I.CDPRECOBASE  = :P_CDPRECOBASE)
                       AND (B.CDPRECOBASE  = I.CDPRECOBASE )
                       AND (B.CDPRODUTO    = I.CDPRODUTO   )
                       AND (B.DTINIVALIPB  = I.DTINIVALIPB )
                       AND ((B.IDDIASPROMO = (TO_CHAR(SYSDATE,'D')))OR(B.IDDIASPROMO ='8'))
                       AND (TO_CHAR(SYSDATE,'DD/MM/YYYY') BETWEEN B.DTINIPROMO AND B.DTFINPROMO)
                    ) X
             WHERE (P.IDPRODATIVPR    = 'S'               )
               AND (I.CDPRODUTO       = P.CDPRODUTO       )
               AND (I.CDPRODUTO       = X.CDPRODUTO    (+))
               AND (I.CDPRECOBASE     = X.CDPRECOBASE  (+))
               AND (I.CDPRECOBASE     = :P_CDPRECOBASE    )
               AND ((INSTR(:P_CDPRODUTO, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN) OR (:P_CDPRODUTO = 'T'))
             ORDER BY P.CDARVPROD";
                
        $params = array(
                'P_PRODINI'       => $row[0]['P_PRODINI'],
                'P_PRODFIN'       => $row[0]['P_PRODFIN'],
                'P_CDPRECOBASE'   => $row[0]['CDPRECOBASE'],
                'P_CDPRODUTO'     =>$row[0]['CDPRODUTO']
        );
            
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
            
    }

     // BUSCO PRODUTOS QUE JA EXISTEM NA PRODPEDWEB
    public function getProdutosWebProd($produto, $row){
        
        $sql = "SELECT * FROM PRODPEDWEB
                WHERE NRSEQWEBSERVICE   = :P_NRSEQWEBSERVICE
                AND CDPRODUTO           = :P_CDPRODUTO";
        
            $params = array(
                'P_NRSEQWEBSERVICE'     => $row[0]['NRSEQWEBSERVICE'],
                'P_CDPRODUTO'           => $produto['CDPRODUTO']
            );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
    // BUSCO PRODUTOS QUE JA EXISTEM NA PRODWEBSYNC
    public function getProdutosWebProdSync($produto, $row){
        
       $sql = "SELECT * FROM PRODWEBSYNC
                WHERE NRSEQWEBSERVICE   = :P_NRSEQWEBSERVICE
                AND CDPRODUTO           = :P_CDPRODUTO";
        
            $params = array(
                'P_NRSEQWEBSERVICE'     => $row[0]['NRSEQWEBSERVICE'],
                'P_CDPRODUTO'           => $produto['CDPRODUTO']
            );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
   
    public function insertProdutoCadAuto($produto, $row){
        try{
            /* INSERE NA PRODPEDWEB */
            $sql = "INSERT INTO PRODPEDWEB
                        (CDPRODUTO, 
                        NRSEQWEBSERVICE)
                    VALUES (:P_CDPRODUTO,
                            :P_NRSEQWEBSERVICE)";
        
            $params = array(
                'P_CDPRODUTO'       => $produto['CDPRODUTO'],
                'P_NRSEQWEBSERVICE' => $row[0]['NRSEQWEBSERVICE']
            );

            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function insertProdutoSyncCadAuto($produto, $row){
        try{
            /* INSERE NA PRODWEBSYNC */
            $sql = "INSERT INTO PRODWEBSYNC 
                        (CDPRODUTO, 
                        NRSEQWEBSERVICE)
                    VALUES (:P_CDPRODUTO,
                            :P_NRSEQWEBSERVICE)";
        
            $params = array(
                'P_CDPRODUTO'       => $produto['CDPRODUTO'],
                'P_NRSEQWEBSERVICE' => $row[0]['NRSEQWEBSERVICE']
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function getModWebped($modalidade, $row){
        $sql = "SELECT * FROM MODPEDWEB
                WHERE NRSEQWEBSERVICE   = :P_NRSEQWEBSERVICE
                AND CDMODPGTO           = :P_CDMODPGTO";
                
        $params = array(
            'P_CDMODPGTO'           => $modalidade['CDMODPGTO'],
            'P_NRSEQWEBSERVICE'     => $row[0]['NRSEQWEBSERVICE']
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    public function getModalidade($row){
        /*BUSCA AS MODALIDADES DE ACORDO COM O INTEVALO SELECIONADO*/
        
        
        $sql="SELECT
                CDMODPGTO,
                DSMODPGTO
            FROM
                MODPGTO
            WHERE
                (( INSTR(:P_CDMODPGTO, CDMODPGTO) > 0)
                  OR (:P_CDMODPGTO = 'T'))
            ORDER BY
                CDMODPGTO,
                DSMODPGTO";
                
        $params = array(
            'P_CDMODPGTO'  =>$row[0]['CDMODPGTO']
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
            
    }
    public function insertModalidadeWebCadAuto($modalidade, $row){
        try{
            /* INSERE NA MODPEDWEB */
            $sql = "INSERT INTO MODPEDWEB
                        (CDMODPGTO, 
                        NRSEQWEBSERVICE)
                    VALUES (:P_CDMODPGTO,
                            :P_NRSEQWEBSERVICE)";
        
            $params = array(
                'P_CDMODPGTO'       => $modalidade['CDMODPGTO'],
                'P_NRSEQWEBSERVICE' => $row[0]['NRSEQWEBSERVICE']
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
}